function [Bo, Bw, Bg, Rs] = local_properties_MB(p, T, qo_sc, qw_sc, qg_sc, qgl_sc)

global gamma_g_0 gamma_gl_0 visc_g_sc_0 GOR_0 R dens_o_sc dens_w_sc p_sc T_sc M_air bara

if qgl_sc~=0
    qg_tot_sc = qg_sc + qgl_sc;
    GOR = qg_tot_sc/qo_sc;
    gamma_g = (qg_sc*gamma_g_0 + qgl_sc*gamma_gl_0)/(qg_tot_sc);
    pBP = bubble_point(GOR, T, gamma_g);
    visc_g_sc = dead_visc_gas(gamma_g);
else  % No GL
    qg_tot_sc = qg_sc;
    GOR = GOR_0;
    gamma_g = gamma_g_0;
    pBP = bubble_point(GOR, T, gamma_g);
    visc_g_sc = visc_g_sc_0;  
end
Rs = solution_GOR(p, T, gamma_g, pBP);
[z, Ppr, Tpr] = z_Standing(p, T, gamma_g);
dens_g_sc = gamma_g*M_air*p_sc*bara/(R*T_sc);
[Bo, Bw, Bg] = FVF (gamma_g, Rs, p, T, z, pBP);



        
end