function [Bo, Bw, Bg] = FVF (gamma_g, Rs, p, T, z, pBP)

global gamma_o p_sc T_sc dens_w_sc

Bg = p_sc*T*z/(p*T_sc);


Bo = 0.9759+0.952*10^(-3)*((gamma_g/gamma_o)^0.5*Rs+0.401*T-103)^1.2;  % Approximates Bo_pBP when Rs=GOR

if T<273.15
    Bw = 0.9759+0.952*10^(-3)*(0.401*T-103)^1.2;  % Ok Approximation?
else
    Bw = dens_w_sc/XSteam('rho_pT', p, T-273.15);
end

if p>pBP
    c = 10^(-4)*(2.81*Rs+3.10*T+171/gamma_o-118*gamma_g-1102)/p;   % Oil compressibility, Vazquez and Beggs (1980)
    Bo = Bo*exp(-c*(p-pBP));
end
end