function [Cpo, Cpg] = HeatCapacity(SGg, T)

global Tbnoil Tbngas gamma_o
SGo = gamma_o;
T = T * 9/5 - 459.67; % Convert temperature from K to F  

Kwoil = (Tbnoil ^ (1 / 3)) / SGo;
Kwgas = (Tbngas ^ (1 / 3)) / SGg;

Cpo = (((0.055 * Kwoil) + 0.35) * (0.6811 - (0.308 * SGo)) + (T * (0.000815 - 0.000306 * SGo))) *4186.8; % [joule/kilogram/K]
Cpg = (((4 - SGg) / 6450) * (T + 670) * ((0.12 * Kwgas) - 0.41)) *4186.8; % [joule/kilogram/K]

% 1 Btu (IT)/pound/F = 4186.800000009 joule/kilogram/K
end