function DPDX = DPDX_gas(d, ULS, UGS, RHOg, VISG, beta)

% Single Phase liquid
global rough
%Testing for single phase liquid flow, and calculation of pressure gradient

if (UGS > 0) 
    
    if ULS>0 % Liquid flowing
        DPDX = 0;
        return
    end
    
% REl = Reynolds number for liquid (oil)
    REL = RHOg * UGS * d / VISG;
    if (REL > 2000) 
        FZ = frictionFactor(d, rough, REL);
        else
        FZ = 16 / REL;
    end 
% Checking for single phase liquid flow
%    Calculate pressure gradient for single phase liquid (Pa/m):
        DPDX = RHOg * 9.81 * sin(beta) + 1/2 * FZ * RHOg * UGS ^ 2 / d;

else
    DPDX = 0;
end


end