function DPDX = DPDX_liquid(d, ULS, UGS, RHOL, VISL, beta)

% Single Phase liquid
global rough
%Testing for single phase liquid flow, and calculation of pressure gradient

if (ULS > 0) 
    
    if UGS>0 % Gas flowing
        DPDX = 0;
        return
    end
    
% REl = Reynolds number for liquid (oil)
    REL = RHOL * ULS * d / VISL;
    if (REL > 2000) 
        FZ = frictionFactor(d, rough, REL);
        else
        FZ = 16 / REL;
    end 
% Checking for single phase liquid flow
%    Calculate pressure gradient for single phase liquid (Pa/m):
        DPDX = RHOL * 9.81 * sin(beta) + 2 * FZ * RHOL * ULS ^ 2 / d;
        
        
else
    DPDX = 0;
end


end