function [p, f_pump, dp_choke] = multiProd_ESP(qo_sc, qw_sc, qg_sc, pR)


global TR pSep pBP_0 h_tubing l_tubing h_flowline l_flowline h_riser l_riser nWells bara day qgl_sc_max
    

pWf = IPR_multi(qo_sc, pBP_0, pR);
step_length = 10; % [m]

%% Pressure drop in tubing
n_steps_t = zeros(1, nWells);
for j = 1:nWells
    n_steps_t(j) = l_tubing(j)/step_length;   % For tubing
    pTubing = zeros(n_steps_t(j)+1, nWells);
end

qgl_sc = zeros(1, nWells);

for j = 1:nWells    
    
    
    theta = asind(h_tubing(j)/l_tubing(j));   % Inclination in degrees from horizontal.
    pTubing (1, j) = pWf(j);
    T = TR;  % Should be made into a function.
    
    
    

    for i = 1:n_steps_t(j)    
        
        
         
         
         [ql, qg, dens_l, dens_g, visc_l, visc_g] = local_properties(pTubing(i, j), T, qo_sc(j), qw_sc(j), qg_sc(j), qgl_sc(count_1, j)); % Local fluid rates and properties 

         dpds = dpBeggs_Brill(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, step_length);   % [Pa]
        
         pTubing(i+1, j) = pTubing(i, j) - dpds/bara;
    end
   if s>0  % Only calculate lowest well.
       break;
   end
    
end

%% Pressure drop in riser and flowline
n_steps_f = (l_riser+l_flowline)/step_length;

pRiser_Flow = zeros(n_steps_f+1, 1);
pRiser_Flow (end) = pSep;
T = TR;  % Should be made into a function.

for i = (n_steps_f):-1:1
    
    if count_2>0 % I.e. there has already been calculated at least one well with GL, and another is in progress.
        sum_gl_sc = 0;
        for k = 1:count_2
            sum_gl_sc = sum_gl_sc + qgl_sc(position_count1(count_2)  , position_s(count_2) );
        end
    else
        sum_gl_sc = sum(qgl_sc(count_1, :));   % I.e. sum of GL rate for all wells in that row. Only GL in max one well.
    end
    
    [ql, qg, dens_l, dens_g, visc_l, visc_g] = local_properties(pRiser_Flow(i+1), T, sum(qo_sc), sum(qw_sc), sum(qg_sc), sum_gl_sc); % Local fluid rates and properties 

    if i<=l_flowline/step_length
        theta = asind(h_flowline/l_flowline);
    else
        theta = asind(h_riser/l_riser);
    end    
    dpds = dpBeggs_Brill(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, step_length);   % [Pa]
        
    pRiser_Flow(i) = pRiser_Flow(i+1) + dpds/bara;
end

if s>0
deltaP(count_1, s) = pTubing(end, s)-pRiser_Flow(1);
temp2 = count_1;
count_1 = count_1 + 1;
else
    break;
end
end

if s>0
    count_2 = count_2+1;
    position_s(count_2) = s;
    position_count1(count_2) = count_1-1;
end


dp_choke = pTubing(end, :) - pRiser_Flow(1);

if (dp_choke+0.1)>=0   % 0.1 is the error margin.
    break;
else
    count_1 = 2;
    s = find(  pTubing(end, :) == min(pTubing(end, :)));
    if length(s)>1
        s = s(1);
    end
    deltaP(1, s) = pTubing(end, s)-pRiser_Flow(1);
end



end





%% Tidy-up section


p = pTubing;
for j =1:nWells
p ( (length(pTubing)+1):(length(pTubing)+length(pRiser_Flow)), j) = pRiser_Flow;
end

for j =1:nWells
    temp = find(qgl_sc(:, j) ~= 0);
    qgl_sc_res(1, j) = qgl_sc(temp(end), j);
end






end