function HTC = HTC_calc(rti, rto, rci, kan, rwb, rco, kcem)

% rti = Tubing inner radius [feet]
% rto = Tubing outer radius [feet]
% rci = Casing inner radius [feet]
% rwb = WellBore inner radius [feet]
% rco = Casing outer radius [feet]
% kan = Annular conductivity [Btu/hr ft F]
% kcem = Cement conductivity [Btu/hr ft F]
% HTC = Overall Heat Transfer Coeff [Btu/hr ft^2 F]

Inverted = rti* ( log(rci/rto)/kan + log(rwb/rco)/kcem);
HTC = Inverted^-1;
end