function res = hccalc(NGr, Npr, ka, rto, rci)
% 'Function to calculate the convective heat transfer coefficient for annulus fluid/Btu/F hr ft^2
% 'Calculates the grashof number for free convection heat transfer calculations in the annulus
% 'Npr, Prandtl Number for annulus
% 'ka, Annular fluid conductivity, Btu/hr ft F
% 'rto, tubing outside radius, ft
% 'rci,casing inside radius, ft
res = (0.049 * ((NGr * Npr) ^ 0.333333) * (Npr ^ 0.074) * ka / (rto * log(rci / rto)));
end