  function [res, Uglobalcalc] = multi_dTdx_tubing(T1, p, theta, rho_m, rho_ns, ge, Cp, holdup, dpds, dvds, Wt, gamma_g, vm, T_amb, hi)

global ro_t k_steel step_length ID_t

%% Calculation of the Joule Thomson Coefficient
% T1 is inlet fluid temperature.
z1 = z_Standing(p, T1, gamma_g);
z2 = z_Standing(p, T1+0.1, gamma_g);
dzdT = (z2-z1)/0.1;
Temperearth = (T_amb - ge*step_length*sind(theta))*9/5-459.67; % Earth temp at outlet. T_amb is at inlet.
eta = -1/(Cp*rho_ns)* ((1-holdup)*(-T1/z1*dzdT) + holdup);


% Calculation of the dimensionless parameter (Ramsey 1962)


fi = (rho_m *eta*Cp*dpds - rho_m*9.81*sind(theta)-rho_m*vm*dvds)/dpds;

%% Calculation of the Heat Transfer 
Layerinfoeach (1) = ID_t/2 * 3.2808399; % Tubing inner radius[Feet]; % Default
Layerinfoeach (2) = ro_t*3.2808399; % Tubing outer radius[Feet]
Layerinfoeach (3) = k_steel/1.7; % Tubing wall conductivity [Btu/hr ft F]
Layerinfoeach (4) = Layerinfoeach (2)+4/12; % Outer radius of Annulus (4") [Feet]
Layerinfoeach (5) = 0.383; % Annulus conductivity [Btu/hr ft F]
Layerinfoeach (6) = 1; % Annular fluid Heat Capacity [Btu/lbm F]
Layerinfoeach (7) = 1; % Annular fluid Viscosity [cp]
Layerinfoeach (8) = 62.373; % Annular fluid density [lbm/ft^3]
Layerinfoeach (9) = Layerinfoeach (4) + 0.8/12; % Casing outer radius (0.8") [Feet]
Layerinfoeach (10) = 21; % Casing conductivity [Btu/hr ft F]
Layerinfoeach (11) = Layerinfoeach (9) + 2/12; % Cement outer radius (2") [Feet]
Layerinfoeach (12) = 4.021; % Cement conductivity [Btu/hr ft F]



kearth = 0.83; % [Btu/hr ft F]
Difearth = 0.04; % [ft^2/hr]
prodtime = 164.0; % [Hr]
Nprcalc = Npr(Layerinfoeach(1, 6), Layerinfoeach(1, 7), Layerinfoeach(1, 5));
td1each = TempD(Td(Difearth, prodtime, Layerinfoeach(11)));

Temp = T1*9/5-459.67; % From Kelvin to Fahrenheit
Uglobal = 8;
 Epsilon = 8;
 while Epsilon >= 0.0001
        Tci = Tcicalc(Temp, td1each, kearth, Layerinfoeach(1, 1), Uglobal, Temperearth, Layerinfoeach(1, 11), Layerinfoeach(1, 9), Layerinfoeach(1, 12), Temp);
%         if Tci <= Temp 
            betaa = (1 / (Annulartemp(Tci, Temp) + 459.67));
            NGrcalc = NGr(Layerinfoeach(1, 4), Layerinfoeach(1, 2), Layerinfoeach(1, 8), betaa, Temp, Tci, Layerinfoeach(1, 7));
            hc = hccalc(NGrcalc, Nprcalc, Layerinfoeach(1, 5), Layerinfoeach(1, 2), Layerinfoeach(1, 4));
            Uglobalcalc = Utocalc(hc, hi, Layerinfoeach(1, 1), Layerinfoeach(1, 2), Layerinfoeach(1, 3), Layerinfoeach(1, 11), Layerinfoeach(1, 9), Layerinfoeach(1, 4), Layerinfoeach(1, 10), Layerinfoeach(1, 12));
            Uglobal = Uglobalcalc;

%% Calculation of the Temperature
     A = Acalc(Cp, Wt, kearth, Layerinfoeach(1, 1), Uglobalcalc, td1each);    

    TempTemp = T_amb - ge*step_length*sind(theta) + (T1-T_amb)*exp(-step_length/A) ...
        + ge*A*sind(theta)*(1-exp(-step_length/A)) + dpds*fi*A*(1-exp(-step_length/A))/(Cp*rho_m);
        
     Epsilon = abs(TempTemp*9/5-459.67 - Temp);
     Temp = TempTemp*9/5-459.67; % From Kelvin to Fahrenheit;
 end
% Uglobalcalc = 2;
%      A = Acalc(Cp, Wt, kearth, Layerinfoeach(1, 1), Uglobalcalc, td1each);    
% 
%      TempTemp = T_amb - ge*step_length*sind(theta) + (T1-T_amb)*exp(-step_length/A) ...
%         + ge*A*sind(theta)*(1-exp(-step_length/A)) + dpds*fi*A*(1-exp(-step_length/A))/(Cp*rho_m);
res = TempTemp;


end