function T2 = multi_dTdx_pipe(T1, p, theta, rho_m, rho_ns, ge, Cp, holdup, dpds, dvds, A, gamma_g, vm, T_amb)

global  step_length
%% Calculation of the Joule Thomson Coefficient

z1 = z_Standing(p, T1, gamma_g);
z2 = z_Standing(p, T1+0.1, gamma_g);
dzdT = (z2-z1)/0.1;

eta = -1/(Cp*rho_ns)* ((1-holdup)*(-T1/z1*dzdT) + holdup);


%% Calculation of the dimensionless parameter (Ramsey 1962)

phi = (rho_m *eta*Cp*dpds - rho_m*9.81*sind(theta)-rho_m*vm*dvds)/dpds;

%% Calculation of the Temperature

T2 = T_amb - ge*step_length*sind(theta) + (T1-T_amb)*exp(-step_length/A) ...
    + ge*A*sind(theta)*(1-exp(-step_length/A)) + dpds*phi*A*(1-exp(-step_length/A))/(Cp*rho_m);
if T2<T_amb
    T2 = T_amb; % Valid approximation?
else

end

end