function [pTubing, pPLEM_WH, pRiser_Flow, p, T, qo_sc_res, qGL_sc_res, dp_choke] = GL_sequential_NR(MolarFlowTot, y_GL, pR, TR)

global  pSep pBP_0 h_tubing l_tubing h_flowline l_flowline h_riser l_riser ...
        nWells bara day MolarFlowGL_max wc MolarFlowTot_min l_PLEM_WH h_PLEM_WH ...
        nManifold wells_in_manifold step_length ID_t ID_f ID_m ...
        h_oil h_gas k_steel  ...
         ro_m ro_f h_sea k_ins ro_ins_m ro_ins_f T_sea Fv_sc Ml_sc dens_o_sc  Mg_sc dens_g_sc
    

[pWf] = IPR_multi(MolarFlowTot, pBP_0, pR);


% qw_sc = MolarFlowTot.*wc; 
% qg_sc = MolarFlowTot.*GOR_0; 
MolarFlowTot_init = MolarFlowTot;
fprintf('dp_choke [bar]: \n\n');
step_length = 100; % [m]

%% Pressure drop in tubing, from Bottom of Well to WH.
n_steps_t = zeros(1, nWells);
for j = 1:nWells
    n_steps_t(j) = l_tubing(j)/step_length;   % For tubing
    pTubing = zeros(n_steps_t(j)+1, nWells);
    TTubing = pTubing;
end



MolarFlowGL = zeros(1, nWells);
dp_choke = zeros(1, nWells);
s = 0;
start = true;
%first_time_problem = true;
first_iteration = true;
reduce_init_rate = false;
reduction_trouble = false;
recalculate = false;
endless_loop_count = ones(1, nWells);

while s>=0
    if s ==0
        temp_1 = 1;
    else
        temp_1=s;
    end
while (abs(dp_choke (1, temp_1)) > 0.1) || start
    start = false;
for j = 1:nWells    
    
    if s>0  % "s" indicates the well that is currently being re-calculated because the pressure is too low.
        j = s;
        if MolarFlowGL(1, j) == 0 && optimal_oil_rate==false  % I.e. first iteration.
            
            dp_choke_old = dp_choke(s);
            MolarFlowGL_old = 0;
            MolarFlowGL(1, j) = MolarFlowGL_max;

        elseif dp_choke(1, j)<0 && MolarFlowGL_old == 0 && optimal_oil_rate==false   % I.e. deltaP(q_gl_max) is too low/below zero.

            if MolarFlowGL(1, j) > (MolarFlowGL_max*0.65^2) % I.e. 3 reduced GL rates
                MolarFlowGL(1, j) = MolarFlowGL(1, j)*0.65;
            else
                % Reduce to oil rate until a valid rate is found (dp_choke>0 with MolarFlowGL_max):
                    
                    MolarFlowTot_old = MolarFlowTot(j);
                    MolarFlowGL(1, j) = MolarFlowGL_max;
                    MolarFlowTot(1, j) = MolarFlowTot(1, j)*(0.9^(endless_loop_count(s))); % This re-calculates the first deltaP for no GL and lower oil rate.
                    [pWf(1, j)] = IPR_multi(MolarFlowTot(1, j), pBP_0, pR);
%                     qw_sc(j) = MolarFlowTot(1, j).*wc(j);
%                     qg_sc(j) = MolarFlowTot(1, j).*GOR_0;

                if MolarFlowTot(1, j)< MolarFlowTot_min 
                    reduce_init_rate = true;
                    reduce_init_well = j;
                    s = 0;
%                     MolarFlowGL = 0;
%                     MolarFlowTot_init = MolarFlowTot_init*0.99;
%                     MolarFlowTot = MolarFlowTot_init;
                    fprintf('Error: pR is too low for well %d to be produced. \n Probable reason is that initial rates in all wells are too high. Rates reduced with 5%%. \n', j);
                    break;
                elseif  pWf(j)<pSep
                    reduce_init_rate = true;
                    reduce_init_well = j;
                    s = 0;
%                     MolarFlowGL = 0;
%                     MolarFlowTot_init = MolarFlowTot_init*0.99;
%                     MolarFlowTot = MolarFlowTot_init;
                    fprintf('Error: pR is too low for well %d to be produced. \n Probable reason is that initial rates in all wells are too high. Rates reduced with 5%%. \n', j);
                    break;
                    
                    
                end

                    reduced_oil_rate = true;
                    first_valid_value = true;
            end
            
            
        else
            
            if reduced_oil_rate  % Solver has found a reduced oil rate that gives positive dp_choke. MolarFlowGL is now kept the same.
                if first_valid_value  % Solver has found the first valid reduced oil rate. This is the first iteration. Because it's uncertain what the valid GL rate is, previous dp_choke's are uncertain. This is calculated now.
                    MolarFlowGL_old = -1;  % Make the old value of zero invalid
                    temp_1 = MolarFlowTot(j); % This is the lower boundary for the oil rate.
                    MolarFlowTot(j) = MolarFlowTot_init(j); %   % Slacker bounds give more stable converging, but also risk the rate being lowered too much (lower bound slack) and the runtime to increase (upper bound slack)          This is the upper boundary for the oil rate = lower_boundary/0.9
                    MolarFlowTot_old = temp_1;
                    dp_choke_old = dp_choke(j); % Newly calculated, positive value.
                    count_rate = 0;
                    first_valid_value = false;
                else
                    count_rate = count_rate+1;
                    if count_rate>20
                        fprintf('The solver has an issue with converging the oil rate for well %d \n\n', s);
                        
                        endless_loop_count(s) = endless_loop_count(s) + 1;
                        
                        reduction_trouble = true;
                        break;
                    end
                    temp_1 = MolarFlowTot(1, j);
                    MolarFlowTot(j) = MolarFlowTot (j) - dp_choke(j)/(dp_choke(j)-dp_choke_old)*(MolarFlowTot(j)-MolarFlowTot_old);
                    
                    MolarFlowTot_old = temp_1;
                    dp_choke_old = dp_choke(j);
                end
                    [pWf(1, j)] = IPR_multi(MolarFlowTot(1, j), pBP_0, pR);
%                     qw_sc(j) = MolarFlowTot(1, j).*wc(j);
%                     qg_sc(j) = MolarFlowTot(1, j).*GOR_0;
                    
                
                
            else
            
            temp_1 = MolarFlowGL(1, j);
            
            MolarFlowGL(1, j) = MolarFlowGL(1, j) - dp_choke(1, j)/(dp_choke(1, j)-dp_choke_old)*(MolarFlowGL(1, j)-MolarFlowGL_old);    % x = x -f(x)/f'(x)
            
            dp_choke_old = dp_choke(1, j);
            MolarFlowGL_old = temp_1;
            
            end

        end
    elseif recalculate
        s = s2;
        j = s;
    end
    
    theta = asind(h_tubing(j)/l_tubing(j));   % Inclination in degrees from horizontal.
    pTubing (1, j) = pWf(j);
    TTubing(1, j) = TR;
    TVD_temp(1, j) = TR;
    ge = (TR-T_sea)/h_tubing(j);  % Geothermal gradient


    for i = 1:n_steps_t(j)    
        
        
        
         
         [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG, gamma_g, Cp] = getPVTproperties(TTubing(i, j), pTubing(i, j), wc, MolarFlowTot(j), MolarFlowGL(j), y_GL); % Local fluid rates and properties 

         if i == 1
             vm_old = (ql+qg)/(pi * (ID_t/2)^2);
         else
             vm_old = vm;
         end
         vm = (ql+qg)/(pi * (ID_t/2)^2);
         
         dvds = (vm-vm_old)/step_length;
         [dpds, rho_m, holdup] = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_t, SIG);   % [Pa]
        % Rho_m is with slip 
         pTubing(i+1, j) = pTubing(i, j) - dpds/bara*step_length;
         hi = (dens_l*ql*h_oil + dens_g*qg*h_gas)/(dens_l*ql+dens_g*qg);  % Fluid convection heat transfer coefficient of mixture. Assumes h_oil =h_water.        
         
         TVD_temp(i+1, j) = TVD_temp(i, j)-ge*step_length*sind(theta);

         Wt = (dens_l*ql+dens_g*qg);

         rho_ns = ql/(ql+qg)*dens_l + qg/(qg+ql)*dens_g;
         TTubing (i+1, j) = multi_dTdx_tubing(TTubing(i, j), pTubing(i+1, j), theta, rho_m, rho_ns, ge, Cp, holdup, -dpds, dvds, Wt, gamma_g, vm, TVD_temp(i, j), hi);
%           [a, b] = multi_dTdx_tubing(TTubing(i, j), pTubing(i+1, j), theta, rho_m, rho_ns, ge, Cp, holdup, -dpds, dvds, Wt, gamma_g, vm, TVD_temp(i, j), hi);
% 
%      TTubing (i+1, j)=a;
%    Utot (i) = b;
        if sum( imag(pTubing(:, j)) )~=0||pTubing(i+1, j)<pSep||isnan(pTubing(i+1, j))
            reduce_init_rate = true;
            reduce_init_well = j;
            pTubing(:, j) = real(pTubing(:, j));  % If pTubing goes below zero, imaginary numbers will be generated.
            break;
        end
         disp(i);
    end
    if reduce_init_rate
        break;
    end
    Cp_Balance_t(j) = Cp*(dens_l*ql+dens_g*qg);
    Temp_Balance_t(j) = Cp_Balance_t(j)*TTubing(n_steps_t(j)+1, j);


    
   if s>0  % Only calculate lowest well.
       break;
   end
    
end

if reduce_init_rate == false;
if reduction_trouble
    reduction_trouble = false;
    break;
end
% Find final nonzero element in tubing (pWh)
for i = 1:nWells
    if pTubing(end, i)==0
        X = find (pTubing(:, i) == 0);
        pTubing_end(i) = pTubing( X(1)-1, i);
    else
        pTubing_end(i) = pTubing(end, i);
    end
    
    
end





%% Pressure drop in riser and flowline, from Sep to PLEM.
n_steps_f = (l_riser+l_flowline)/step_length;

pRiser_Flow = zeros(n_steps_f+1, 1);
TRiser_Flow = pRiser_Flow;
pRiser_Flow (end) = pSep;

for i = (n_steps_f):-1:1
     
    [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG] = getPVTproperties(TR, pRiser_Flow(i+1), wc, sum(MolarFlowTot), sum(MolarFlowGL), y_GL); % Local fluid rates and properties 

    if i<=l_flowline/step_length  % I.e. is the calculation in the flowline or in the riser
        theta = asind(h_flowline/l_flowline);
    else
        theta = asind(h_riser/l_riser);
    end    
    
     dpds = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_f, SIG);   % [Pa]
        % Rho_m is with slip (check formulas if this is true)
     pRiser_Flow(i) = pRiser_Flow(i+1) + dpds/bara*step_length;
          
end


n_steps_m = zeros(1, nManifold);  % Steps from PLEM to Manifold
for j = 1:nManifold
    n_steps_m(j) = l_PLEM_WH(j)/step_length;   % For tubing
end
pPLEM_WH = zeros(  max(n_steps_m)+1, nManifold);
pPLEM_WH(end, :) = pRiser_Flow(1, :);



for r = 1: nManifold   % "r" is a new variabel so not to disturb "j" from the tubing-section.
    
    % To keep track of which wells are calculated:
    temp_10=0;
    for y = 1:r
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    
    for i = ( max(n_steps_m) ):-1: ( max(n_steps_m) - n_steps_m(r)+1   )
        

        
        
        [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG] = getPVTproperties(TR, pPLEM_WH(i+1, r), wc, sum(MolarFlowTot(temp_9+1:temp_10)), sum(MolarFlowGL(temp_9+1:temp_10)), y_GL); % Local fluid rates and properties 
        
        theta = asind(h_PLEM_WH(r)/l_PLEM_WH(r));
    
        dpds = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_m(r), SIG);   % [Pa]
        
        pPLEM_WH(i, r) = pPLEM_WH(i+1, r) + dpds/bara*step_length;
    end
    
end

for i = 1:nManifold
    if pPLEM_WH(1, i)==0
        X = find (pPLEM_WH(:, i) == 0);
        Calc_start(i) = X(end)+1;
        pPLEM_WH_end(1, i) = pPLEM_WH( X(end)+1, i);
    else
        pPLEM_WH_end(1, i) = pPLEM_WH(1, i);
        Calc_start(i) = 1;
    end 
end

%% Find temperature in Manifold
TPLEM_WH = zeros(size(pPLEM_WH));
for i = 1:nManifold
    temp_10=0;
    for y = 1:i
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    
    TPLEM_WH(Calc_start(i), i) = sum(Temp_Balance_t(temp_9+1:temp_10))/sum(Cp_Balance_t(temp_9+1:temp_10));
end

for r = 1: nManifold   % "r" is a new variabel so not to disturb "j" from the tubing-section.
    
    % To keep track of which wells are calculated:
    temp_10=0;
    for y = 1:r
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    
    for i = ( max(n_steps_m)  - n_steps_m(r)+1  ): ( max(n_steps_m)  )
        

        
        
        [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG, gamma_g, Cp] = getPVTproperties(TPLEM_WH(i, r), pPLEM_WH(i, r), wc, sum(MolarFlowTot(temp_9+1:temp_10)), sum(MolarFlowGL(temp_9+1:temp_10)), y_GL); % Local fluid rates and properties 
        
        theta = asind(h_PLEM_WH(r)/l_PLEM_WH(r));
    
         if i == 1
             vm_old = (ql+qg)/(pi * (ID_m(r)/2)^2);
         else
             vm_old = vm;
         end
         vm = (ql+qg)/(pi * (ID_m(r)/2)^2);
         
         dvds = (vm-vm_old)/step_length;
         [dpds, rho_m, holdup] = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_m(r), SIG);   % [Pa]

         
         hi = (dens_l*ql*h_oil + dens_g*qg*h_gas)/(dens_l*ql+dens_g*qg);  % Fluid convection heat transfer coefficient of mixture.
         HTC = 1/( ro_ins_m(r)/(hi*ID_m(r)/2) + log(2*ro_m(r)/ID_m(r))*ro_ins_m(r)/k_steel ...
             + ro_ins_m(r)*log(ro_ins_m(r)/ro_m(r))/k_ins  + 1/h_sea);
         % Calculation of relaxation distance (Ramsey 1962)
         A = (dens_l*ql+dens_g*qg)*Cp/(2*HTC*pi*ro_ins_m(r));
         rho_ns = ql/(ql+qg)*dens_l + qg/(qg+ql)*dens_g;
         TPLEM_WH(i+1, r) = multi_dTdx_pipe(TPLEM_WH(i, r), pPLEM_WH(i+1, r), theta, rho_m, rho_ns, 0, Cp, holdup, -dpds, dvds, A, gamma_g, vm, T_sea);
        %  TPLEM_WH(i+1, r) = TR;
    end
    Cp_Balance_m(r) = Cp*(dens_l*ql+dens_g*qg);
    Temp_Balance_m(r) = Cp_Balance_m(r)*TPLEM_WH(end, r);
    
end
TRiser_Flow (1) = sum(Temp_Balance_m(:))/sum(Cp_Balance_m(:));
for i = 1:(n_steps_f)
     
    [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG, gamma_g, Cp] = getPVTproperties(TRiser_Flow (i), pRiser_Flow(i), wc, sum(MolarFlowTot), sum(MolarFlowGL), y_GL); % Local fluid rates and properties 

    if i<=l_flowline/step_length  % I.e. is the calculation in the flowline or in the riser
        theta = asind(h_flowline/l_flowline);
    else
        theta = asind(h_riser/l_riser);
    end    
    
         if i == 1
             vm_old = (ql+qg)/(pi * (ID_f/2)^2);
         else
             vm_old = vm;
         end
         vm = (ql+qg)/(pi * (ID_f/2)^2);
         
         dvds = (vm-vm_old)/step_length;
         [dpds, rho_m, holdup] = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_f, SIG);   % [Pa]

         
         hi = (dens_l*ql*h_oil + dens_g*qg*h_gas)/(dens_l*ql+dens_g*qg);  % Fluid convection heat transfer coefficient of mixture.
         HTC = 1/( ro_ins_f/(hi*ID_f/2) + log(2*ro_f/ID_f)*ro_ins_f/k_steel ...
             + ro_ins_f*log(ro_ins_f/ro_f)/k_ins  + 1/h_sea);
         % Calculation of relaxation distance (Ramsey 1962)
         A = (dens_l*ql+dens_g*qg)*Cp/(2*HTC*pi*ro_ins_f);
         rho_ns = ql/(ql+qg)*dens_l + qg/(qg+ql)*dens_g;
         TRiser_Flow (i+1) = multi_dTdx_pipe(TRiser_Flow (i), pRiser_Flow (i), theta, rho_m, rho_ns, 0, Cp, holdup, -dpds, dvds, A, gamma_g, vm, T_sea);
         %TRiser_Flow (i+1) = TR;
          
end

for i = (n_steps_f):-1:1
     
    [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG] = getPVTproperties(TRiser_Flow(i+1), pRiser_Flow(i+1), wc, sum(MolarFlowTot), sum(MolarFlowGL), y_GL); % Local fluid rates and properties 

    if i<=l_flowline/step_length  % I.e. is the calculation in the flowline or in the riser
        theta = asind(h_flowline/l_flowline);
    else
        theta = asind(h_riser/l_riser);
    end    
    
     dpds = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_f, SIG);   % [Pa]
        % Rho_m is with slip (check formulas if this is true)
     pRiser_Flow(i) = pRiser_Flow(i+1) + dpds/bara*step_length;
          
end

pPLEM_WH(end, :) = pRiser_Flow(1, :);



for r = 1: nManifold   % "r" is a new variabel so not to disturb "j" from the tubing-section.
    
    % To keep track of which wells are calculated:
    temp_10=0;
    for y = 1:r
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    
    for i = ( max(n_steps_m) ):-1: ( max(n_steps_m) - n_steps_m(r)+1   )
        

        
        
        [ql, qg, dens_l, dens_g, visc_l, visc_g, SIG] = getPVTproperties(TPLEM_WH(i+1, r), pPLEM_WH(i+1, r), wc, sum(MolarFlowTot(temp_9+1:temp_10)), sum(MolarFlowGL(temp_9+1:temp_10)), y_GL); % Local fluid rates and properties 
        
        theta = asind(h_PLEM_WH(r)/l_PLEM_WH(r));
    
        dpds = multi_dpdx(ql, qg, dens_l, dens_g, visc_l, visc_g, theta, ID_m(r), SIG);   % [Pa]
        
        pPLEM_WH(i, r) = pPLEM_WH(i+1, r) + dpds/bara*step_length;
    end
    
end
















for i = 1:nManifold
    temp_10=0;
    for y = 1:i
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    
    dp_choke(1, temp_9+1:temp_10) = pTubing_end (1, temp_9+1:temp_10) - pPLEM_WH_end(1, i);
end

disp(dp_choke);
end

if s>0
    if recalculate
        recalculate = false;
        MolarFlowGL_old = -1;
        if dp_choke(s)>0 % Recalculated well with positive choke, initial rates and no GL
            break;
        end
    end
    temp_1 = s;
else
    break;
end
    
    
    
end


if s>0
    if endless_loop_count(s)==10
        fprintf('Program run into an endless loop of re-iteration for well %d. Program stops and returns values close to target. \n\n', s);
       break;
    end
end


disp(dp_choke);
    if isnan(sum(dp_choke))||reduce_init_rate % Imaginary numbers due to high oil rate
        reduce_init_rate = false;
        s = 0;
        %MolarFlowGL(1, 1:nWells) = MolarFlowGL_max;
        start = true;
        if MolarFlowTot_init(reduce_init_well)== 0
            MolarFlowGL(reduce_init_well) = MolarFlowGL_max;
        else
            MolarFlowTot_init(reduce_init_well) = MolarFlowTot_init(reduce_init_well)*0.9;
        end
        
        MolarFlowTot = MolarFlowTot_init;
        [pWf] = IPR_multi(MolarFlowTot, pBP_0, pR);
%         qw_sc = MolarFlowTot.*wc;
%         qg_sc = MolarFlowTot.*GOR_0;
        %fprintf('Error: Too high rates in some of the wells result in NaN. All rates reduced by 1%%. \n');
    elseif first_iteration
        first_iteration = false;
        if dp_choke<0 % For all wells
            MolarFlowGL (1, 1:nWells) = MolarFlowGL_max;
        end
    else

        

if (dp_choke+0.1)>=0   % 0.1 is the error margin. If dpChoke>0 then no GL.
    count = [];
    for i = 1:nWells
        if dp_choke(i)>0.1
            if (MolarFlowGL(i)>0 || MolarFlowTot(i)<MolarFlowTot_init(i)-10^(-10))
                count = [count i];
            end
        end
    end
    
    if isempty(count)
        break;
    else
        reduced_oil_rate = false;
        optimal_oil_rate = false;
    
        s = find(  dp_choke(:) == max(dp_choke  (count)));   % S equals the well with the lowest pressure at WH.
        if length(s)>1
            s = s(1);    % If multiple wells have equal lowst pressure at WH, start with first one.
        end
        MolarFlowGL_old = -1;  % Wrong value to get the solver started.
        MolarFlowGL(s) = 0; % Calculations starting with reduced rates.
        MolarFlowTot(s) = MolarFlowTot_init(s);
        [pWf(1, s)] = IPR_multi(MolarFlowTot(1, s), pBP_0, pR);
%         qw_sc(s) = MolarFlowTot(1, s).*wc(s);
%         qg_sc(s) = MolarFlowTot(1, s).*GOR_0;
        s2 = s;
        s = 0;
        recalculate = true;
        start = true;
    end
else
    reduced_oil_rate = false;
    optimal_oil_rate = false;
    
    s = find(  dp_choke(:) == min(dp_choke  (:)));   % S equals the well with the lowest pressure at WH.
    if length(s)>1
        s = s(1);    % If multiple wells have equal lowst pressure at WH, start with first one.
    end
        MolarFlowGL_old = -1;  % Wrong value to get the solver started.
        if MolarFlowGL(s)>0 % I.e. re-calculation of GL-rate
            MolarFlowGL(s) = 0; % Calculations starting with reduced rates.
            MolarFlowTot(s) = MolarFlowTot_init(s);
            [pWf(1, s)] = IPR_multi(MolarFlowTot(1, s), pBP_0, pR);
%             qw_sc(s) = MolarFlowTot(1, s).*wc(s);
%             qg_sc(s) = MolarFlowTot(1, s).*GOR_0;
            s2 = s;
            s = 0;
            recalculate = true;
            start = true;
        end
end

if  s>0 % The previous calculation resultet in infeasible solution (close to correct solution), but will continue in an endless loop. This answer is anyway close to the solution.
    if endless_loop_count(s)==1
        endless_loop_count(:) = 1;
    end

end
    end

end





%% Tidy-up section

% Pressures and Temperatures in the pipes:
p = zeros( (length(pTubing(:, 1))+length(pPLEM_WH(:, 1))+length(pRiser_Flow(:, 1)))-1, nWells);
p(1:length(pTubing), :) = pTubing;

T = zeros( (length(pTubing(:, 1))+length(pPLEM_WH(:, 1))+length(pRiser_Flow(:, 1)))-1, nWells);
T(1:length(pTubing), :) = TTubing;

for i = 1:nManifold
    temp_10=0;
    for y = 1:i
        temp_9 = temp_10;
        temp_10 = temp_10+wells_in_manifold(y);
    end
    for a = temp_9+1:temp_10
        p( (length(pTubing(:, 1))+1):(length(pTubing(:, 1))+length(pPLEM_WH(:, 1))) , a) = pPLEM_WH(:, i);
        T( (length(pTubing(:, 1))+1):(length(pTubing(:, 1))+length(pPLEM_WH(:, 1))) , a) = TPLEM_WH(:, i);
    end
    
end

for j =1:nWells
p ( (length(pTubing(:, 1))+length(pPLEM_WH(:, 1))):(length(pTubing(:, 1))+length(pPLEM_WH(:, 1))+length(pRiser_Flow(:, 1)))-1, j) = pRiser_Flow;
T ( (length(pTubing(:, 1))+length(pPLEM_WH(:, 1))):(length(pTubing(:, 1))+length(pPLEM_WH(:, 1))+length(pRiser_Flow(:, 1)))-1, j) = TRiser_Flow;
end

% GL rates:
for j =1:nWells
    temp = find(MolarFlowGL(:, j) ~= 0);
    if isempty(temp)
        MolarFlowGL_res(1, j) = 0;
    else
        MolarFlowGL_res(1, j) = MolarFlowGL(temp(end), j);
    end
end
MolarFlowGL_res = MolarFlowGL_res*day;

% Oil rates:
size_oil = size(MolarFlowTot);
if size_oil(1)>1 % I.e. at least one well is calculated with reduced oil rate.
    MolarFlowTot_res = zeros(1, nWells);
    for k = 1:nWells
        nonzero_value = find(MolarFlowTot(:, k) ~=0);
        correct_value = nonzero_value(end);
        MolarFlowTot_res(k) = MolarFlowTot(correct_value, k)*day;
    end
else
    MolarFlowTot_res = MolarFlowTot*day;   % I.e. Original oil rates count.
end

qo_sc_res = MolarFlowTot_res*(1-Fv_sc)*Ml_sc/dens_o_sc;
qGL_sc_res = MolarFlowGL_res*Mg_sc/dens_g_sc;


fprintf('Calculated oil rates [Sm3/D]: \n\n');
format short g;
disp(qo_sc_res);
fprintf('Calculated GL rates [Sm3/D]: \n\n');
disp(qGL_sc_res);


end