function res = Utocalc(hc, hi, rti, rto, kt, rwb, rco, rci, kcas, kcem)
% 'Function to calculate the overall heat transfer coefficient, Btu/hr*ft^2*F
% 'hc, convective heat transfer coefficient for annulus fluid  Btu/F hr ft^2
% 'rto, tubing outside radious, ft
% 'rwb, Outside radius of wellbore, ft
% 'rco, outside radius of casing, ft
% 'kcem, cement conductivity, Btu/hr ft F

hi = hi*0.176110184;
res = (  rti/(rti*hi) + rti*log(rto/rti)/kt + (rti /rto* hc) + rti*log(rco/rci)/kcas + (rti * log(rwb / rco) / kcem)   ) ^ -1;

end