function [pR_2, IOIP_2, IGIP_2, IWIP_2] = Mass_Balance(qo, qg, qw, pR, TR, IOIP, IGIP, IWIP)

global GOR_0

Prod_Days = 350/2;
Np = qo*Prod_Days;
Gp = qg*Prod_Days;
Wp = qw*Prod_Days;
Cr = 10^-5*14.5;
Cw = 10^-4;

m = IGIP/IOIP; % At initial conditions
Sw = IWIP/(IWIP+IGIP+IOIP);  % At initial conditions

f_new = 1;
pR_new = pR-5;
while abs(f_new)>0.0000001

[Bo, Bw, Bg, Rs] = local_properties_MB(pR, TR, qo, qw, qg, 0);  % Witout GL, At initial conditions
[Bo_2, Bw_2, Bg_2, Rs_2] = local_properties_MB(pR_new, TR, qo, qw, qg, 0);  % Witout GL, At new conditions

F = Np*(Bo_2-Rs_2*Bg_2)+Wp*Bw_2+Gp*Bg_2;
Eo = (Bo_2-Bo)+(Rs-Rs_2)*Bg_2;
Eg = Bo*(Bg_2/Bg-1);
Efw = -(1+m)*Bo*(Cr+Cw*Sw)*(pR_new-pR)/(1-Sw);
% Newton Raphson:
f_new = IOIP*(Eo+m*Eg+Efw)+IGIP*Bg_2-F;

if pR_new == pR-5
    f_old = f_new;
    pR_old = pR_new;
    pR_new = pR - 2.5;
else
    df = f_new - f_old;
    f_old = f_new;
    temp = pR_new;
    pR_new = pR_new - f_new/df*(pR_new - pR_old);
    pR_old = temp;
end
end
pR_2 = pR_new;

IOIP_2 = IOIP - Np;
if GOR_0<Rs
    Rs = GOR_0;
end
IGIP_2 = IGIP - (GOR_0-Rs)*Gp;
IWIP_2 = IWIP - Wp;

end